import { ProjectView } from '../../../projects/sqtm-core/src/lib/model/project/project.model';
import { WorkspaceTypeForPlugins } from '../../../projects/sqtm-core/src/lib/model/project/project-data.model';
import { combineWithDefaultData } from './data-mocks.utils';
import {
  RemoteSelectType,
  RemoteSynchronisation,
  SynchronizationStatus,
  SynchronizationViewPlugin,
  SystemViewModel,
} from '../../../projects/sqtm-core/src/lib/model/system/system-view.model';
import { User } from '../../../projects/sqtm-core/src/lib/model/user/user.model';
import { Team } from '../../../projects/sqtm-core/src/lib/model/team/team.model';
import { MilestoneAdminView } from '../../../projects/sqtm-core/src/lib/model/milestone/milestone.model';
import {
  AdminTestAutomationServer,
  TestAutomationServerKind,
} from '../../../projects/sqtm-core/src/lib/model/test-automation/test-automation-server.model';
import {
  AuthenticationPolicy,
  AuthenticationProtocol,
} from '../../../projects/sqtm-core/src/lib/model/third-party-server/authentication.model';
import { BugTrackerReferentialDto } from '../../../projects/sqtm-core/src/lib/model/bugtracker/bug-tracker.model';
import { AclGroup } from '../../../projects/sqtm-core/src/lib/model/permissions/permissions.model';
import { ALL_PROJECT_PERMISSIONS } from '../utils/referential/referential-data-builder';

export function makeProjectViewData(customData?: Partial<ProjectView>): ProjectView {
  const defaultData: ProjectView = {
    id: 4,
    name: 'Project1',
    label: null,
    testCaseNatureId: 2,
    testCaseTypeId: 3,
    requirementCategoryId: 4,
    allowAutomationWorkflow: true,
    customFieldBindings: {
      CAMPAIGN_FOLDER: [],
      TESTCASE_FOLDER: [],
      REQUIREMENT_VERSION: [],
      REQUIREMENT_FOLDER: [],
      TEST_SUITE: [],
      ITERATION: [],
      TEST_CASE: [],
      TEST_STEP: [],
      CAMPAIGN: [],
      EXECUTION: [],
      CUSTOM_REPORT_FOLDER: [],
      EXECUTION_STEP: [],
      SPRINT: [],
      SPRINT_GROUP: [],
    },
    permissions: ALL_PROJECT_PERMISSIONS,
    availableAiServers: [],
    aiServerId: null,
    availableBugtrackers: [],
    bugTrackerBinding: null,
    bugtrackerProjectNames: null,
    milestoneBindings: [],
    taServerId: null,
    automationWorkflowType: 'NATIVE',
    disabledExecutionStatus: [],
    attachmentList: {
      id: 519,
      attachments: [
        {
          id: 7,
          name: 'demo_sprint_7.pdf',
          size: 152088,
          addedOn: new Date(),
          lastModifiedOn: null,
        },
      ],
    },
    template: false,
    linkedTemplateId: 2,
    linkedTemplate: 'Template1',
    createdOn: new Date().toISOString(),
    createdBy: 'admin',
    lastModifiedOn: new Date().toISOString(),
    lastModifiedBy: 'admin',
    allowTcModifDuringExec: false,
    allowedStatuses: { SETTLED: false, UNTESTABLE: false },
    statusesInUse: { SETTLED: false, UNTESTABLE: false },
    description: '',
    uri: '',
    infoLists: mockInfoLists(),
    useTreeStructureInScmRepo: false,
    templateLinkedToProjects: false,
    partyProjectPermissions: [],
    availableScmServers: [],
    availableTestAutomationServers: [],
    boundTestAutomationProjects: [],
    boundMilestonesInformation: [],
    availablePlugins: [],
    keywords: undefined,
    bddScriptLanguage: undefined,
    scmRepositoryId: undefined,
    activatedPlugins: {
      [WorkspaceTypeForPlugins.CAMPAIGN_WORKSPACE]: [],
      [WorkspaceTypeForPlugins.TEST_CASE_WORKSPACE]: [],
      [WorkspaceTypeForPlugins.REQUIREMENT_WORKSPACE]: [],
    },
    automatedSuitesLifetime: 0,
    bddImplementationTechnology: 'CUCUMBER_4',
    allProjectBoundToTemplate: [],
    hasData: true,
    hasTemplateConfigurablePluginBinding: false,
    availableProfiles: [
      {
        id: 1,
        qualifiedName: AclGroup.PROJECT_MANAGER,
        active: true,
        system: true,
      },
      {
        id: 1,
        qualifiedName: AclGroup.TEST_EDITOR,
        active: true,
        system: true,
      },
    ],
    existingImports: [],
  };

  return combineWithDefaultData(defaultData, customData);
}

function mockInfoLists() {
  return [
    {
      id: 1,
      uri: null,
      code: 'DEF_REQ_CAT',
      label: 'infolist.category.default',
      description: '',
      items: [
        {
          id: 1,
          uri: null,
          code: 'CAT_FUNCTIONAL',
          label: 'requirement.category.CAT_FUNCTIONAL',
          friendlyLabel: null,
          iconName: 'monitor',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 2,
          uri: null,
          code: 'CAT_NON_FUNCTIONAL',
          label: 'requirement.category.CAT_NON_FUNCTIONAL',
          friendlyLabel: null,
          iconName: 'server',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 3,
          uri: null,
          code: 'CAT_USE_CASE',
          label: 'requirement.category.CAT_USE_CASE',
          friendlyLabel: null,
          iconName: 'read',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 4,
          uri: null,
          code: 'CAT_BUSINESS',
          label: 'requirement.category.CAT_BUSINESS',
          friendlyLabel: null,
          iconName: 'briefcase',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 5,
          uri: null,
          code: 'CAT_TEST_REQUIREMENT',
          label: 'requirement.category.CAT_TEST_REQUIREMENT',
          friendlyLabel: null,
          iconName: 'checked_checkbox',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 6,
          uri: null,
          code: 'CAT_UNDEFINED',
          label: 'requirement.category.CAT_UNDEFINED',
          friendlyLabel: null,
          iconName: 'indeterminate_checkbox_empty',
          itemIndex: null,
          default: true,
          system: true,
          denormalized: false,
        },
        {
          id: 7,
          uri: null,
          code: 'CAT_ERGONOMIC',
          label: 'requirement.category.CAT_ERGONOMIC',
          friendlyLabel: null,
          iconName: 'puzzle',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 8,
          uri: null,
          code: 'CAT_PERFORMANCE',
          label: 'requirement.category.CAT_PERFORMANCE',
          friendlyLabel: null,
          iconName: 'dashboard',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 9,
          uri: null,
          code: 'CAT_TECHNICAL',
          label: 'requirement.category.CAT_TECHNICAL',
          friendlyLabel: null,
          iconName: 'key',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 10,
          uri: null,
          code: 'CAT_USER_STORY',
          label: 'requirement.category.CAT_USER_STORY',
          friendlyLabel: null,
          iconName: 'bookmark',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 11,
          uri: null,
          code: 'CAT_SECURITY',
          label: 'requirement.category.CAT_SECURITY',
          friendlyLabel: null,
          iconName: 'protect',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
      ],
    },
    {
      id: 2,
      uri: null,
      code: 'DEF_TC_NAT',
      label: 'infolist.nature.default',
      description: '',
      items: [
        {
          id: 12,
          uri: null,
          code: 'NAT_UNDEFINED',
          label: 'test-case.nature.NAT_UNDEFINED',
          friendlyLabel: null,
          iconName: 'indeterminate_checkbox_empty',
          itemIndex: null,
          default: true,
          system: true,
          denormalized: false,
        },
        {
          id: 13,
          uri: null,
          code: 'NAT_FUNCTIONAL_TESTING',
          label: 'test-case.nature.NAT_FUNCTIONAL_TESTING',
          friendlyLabel: null,
          iconName: 'monitor',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 14,
          uri: null,
          code: 'NAT_BUSINESS_TESTING',
          label: 'test-case.nature.NAT_BUSINESS_TESTING',
          friendlyLabel: null,
          iconName: 'briefcase',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 15,
          uri: null,
          code: 'NAT_USER_TESTING',
          label: 'test-case.nature.NAT_USER_TESTING',
          friendlyLabel: null,
          iconName: 'user',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 16,
          uri: null,
          code: 'NAT_NON_FUNCTIONAL_TESTING',
          label: 'test-case.nature.NAT_NON_FUNCTIONAL_TESTING',
          friendlyLabel: null,
          iconName: 'server',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 17,
          uri: null,
          code: 'NAT_PERFORMANCE_TESTING',
          label: 'test-case.nature.NAT_PERFORMANCE_TESTING',
          friendlyLabel: null,
          iconName: 'dashboard',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 18,
          uri: null,
          code: 'NAT_SECURITY_TESTING',
          label: 'test-case.nature.NAT_SECURITY_TESTING',
          friendlyLabel: null,
          iconName: 'protect',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 19,
          uri: null,
          code: 'NAT_ATDD',
          label: 'test-case.nature.NAT_ATDD',
          friendlyLabel: null,
          iconName: 'circular_arrows',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
      ],
    },
    {
      id: 3,
      uri: null,
      code: 'DEF_TC_TYP',
      label: 'infolist.type.default',
      description: '',
      items: [
        {
          id: 20,
          uri: null,
          code: 'TYP_UNDEFINED',
          label: 'test-case.type.TYP_UNDEFINED',
          friendlyLabel: null,
          iconName: 'indeterminate_checkbox_empty',
          itemIndex: null,
          default: true,
          system: true,
          denormalized: false,
        },
        {
          id: 21,
          uri: null,
          code: 'TYP_COMPLIANCE_TESTING',
          label: 'test-case.type.TYP_COMPLIANCE_TESTING',
          friendlyLabel: null,
          iconName: 'task_completed',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 22,
          uri: null,
          code: 'TYP_CORRECTION_TESTING',
          label: 'test-case.type.TYP_CORRECTION_TESTING',
          friendlyLabel: null,
          iconName: 'bug',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 23,
          uri: null,
          code: 'TYP_EVOLUTION_TESTING',
          label: 'test-case.type.TYP_EVOLUTION_TESTING',
          friendlyLabel: null,
          iconName: 'circled_up_right',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 24,
          uri: null,
          code: 'TYP_REGRESSION_TESTING',
          label: 'test-case.type.TYP_REGRESSION_TESTING',
          friendlyLabel: null,
          iconName: 'circular_arrows',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 25,
          uri: null,
          code: 'TYP_END_TO_END_TESTING',
          label: 'test-case.type.TYP_END_TO_END_TESTING',
          friendlyLabel: null,
          iconName: 'journey',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
        {
          id: 26,
          uri: null,
          code: 'TYP_PARTNER_TESTING',
          label: 'test-case.type.TYP_PARTNER_TESTING',
          friendlyLabel: null,
          iconName: 'handshake',
          itemIndex: null,
          default: false,
          system: true,
          denormalized: false,
        },
      ],
    },
    {
      id: 4,
      uri: null,
      code: 'custom_list',
      label: 'My custom list',
      description: '',
      items: [
        {
          id: 22,
          uri: null,
          code: 'red',
          label: 'Rouge',
          friendlyLabel: null,
          iconName: 'indeterminate_checkbox_empty',
          itemIndex: null,
          default: true,
          system: false,
          denormalized: false,
        },
        {
          id: 23,
          uri: null,
          code: 'blue',
          label: 'Bleu',
          friendlyLabel: null,
          iconName: 'task_completed',
          itemIndex: null,
          default: false,
          system: false,
          denormalized: false,
        },
      ],
    },
  ];
}

export function makeSystemViewData(customData?: Partial<SystemViewModel>): SystemViewModel {
  const defaultData: SystemViewModel = {
    appVersion: 'VERSION',
    plugins: ['PLUGIN1', 'PLUGIN2'],
    statistics: {
      testcaseIndexingDate: null,
      requirementIndexingDate: null,
      campaignIndexingDate: null,
      projectsNumber: 1,
      usersNumber: 12,
      requirementsNumber: 123,
      testCasesNumber: 1234,
      campaignsNumber: 12345,
      iterationsNumber: 321,
      executionsNumber: 2,
      databaseSize: 10000,
    },
    callbackUrl: 'localhost:8080/squash',
    caseInsensitiveLogin: false,
    duplicateLogins: [],
    caseInsensitiveActions: false,
    duplicateActions: [],
    importSizeLimit: '10000',
    loginMessage: 'Login message',
    welcomeMessage: 'Welcome message',
    bannerMessage: null,
    stackTraceFeatureIsEnabled: false,
    stackTracePanelIsVisible: true,
    uploadSizeLimit: '1000',
    whiteList: '',
    logFiles: [],
    autoconnectOnConnection: false,
    licenseInfo: null,
    currentActiveUsersCount: null,
    reportTemplateModels: [],
    synchronisationPlugins: mockSynchronizationPluginsData(),
    unsafeAttachmentPreviewEnabled: false,
  };

  return combineWithDefaultData(defaultData, customData);
}

export function mockSynchronizationPluginsData(): SynchronizationViewPlugin[] {
  return [
    {
      id: 'henix.plugin.automation.workflow.automjira',
      name: 'Workflow Automatisation Jira',
      remoteSynchronisations: mockAutomJiraRemoteSyncData(),
      hasSupervisionScreen: true,
      supervisionScreenData: {
        hasPerimeterColumn: false,
        hasSyncNameColumn: false,
        hasRemoteSelectTypeColumn: false,
        hasSynchronizedRequirementsRatioColumn: false,
        hasSynchronizedSprintTicketsRatioColumn: false,
      },
    },
    {
      id: 'squash.tm.plugin.jirasync',
      name: 'Xsquash4Jira',
      remoteSynchronisations: mockXsquash4JiraRemoteSyncData(),
      hasSupervisionScreen: true,
      supervisionScreenData: {
        hasPerimeterColumn: false,
        hasSyncNameColumn: true,
        hasRemoteSelectTypeColumn: true,
        hasSynchronizedRequirementsRatioColumn: true,
        hasSynchronizedSprintTicketsRatioColumn: true,
      },
    },
    {
      id: 'squash.tm.plugin.xsquash4gitlab',
      name: 'Xsquash4GitLab',
      remoteSynchronisations: mockXsquash4GitLabRemoteSyncData(),
      hasSupervisionScreen: true,
      supervisionScreenData: {
        hasPerimeterColumn: true,
        hasSyncNameColumn: true,
        hasRemoteSelectTypeColumn: false,
        hasSynchronizedRequirementsRatioColumn: true,
        hasSynchronizedSprintTicketsRatioColumn: true,
      },
    },
  ];
}

export function mockAutomJiraRemoteSyncData(): RemoteSynchronisation[] {
  const todayDate = new Date().toISOString();

  return [
    {
      id: 1,
      name: 'automJiraSync',
      serverId: 1,
      serverName: 'Autom Jira Server',
      projectId: 1,
      projectName: 'project 1',
      perimeter: '',
      remoteSelectType: RemoteSelectType.QUERY,
      remoteSelectValue: '',
      status: SynchronizationStatus.SUCCESS,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: true,
      syncErrorLogFilePath: '',
    },
    {
      id: 2,
      name: 'automJiraSync',
      serverId: 1,
      serverName: 'Autom Jira Server',
      projectId: 2,
      projectName: 'project 2',
      perimeter: '',
      remoteSelectType: RemoteSelectType.QUERY,
      remoteSelectValue: '',
      status: SynchronizationStatus.FAILURE,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: true,
      syncErrorLogFilePath: '',
    },
  ];
}

export function mockXsquash4JiraRemoteSyncData(): RemoteSynchronisation[] {
  const todayDate = new Date().toISOString();

  return [
    {
      id: 1,
      name: 'Jira Sync 1',
      serverId: 2,
      serverName: 'Jira Server',
      projectId: 1,
      projectName: 'example project 1',
      perimeter: '',
      remoteSelectType: RemoteSelectType.QUERY,
      remoteSelectValue: 'myValue',
      status: SynchronizationStatus.FAILURE,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: false,
      synchronizedRequirementsCount: 10,
      unprocessedRequirementsCount: 0,
      synchronizedSprintTicketsCount: 5,
      unprocessedSprintTicketsCount: 2,
      syncErrorLogFilePath: '../logs/xsquash4jira/sync-1-error.log',
    },
    {
      id: 2,
      name: 'Jira Sync 2',
      serverId: 2,
      serverName: 'Jira Server',
      projectId: 2,
      projectName: 'example project 2',
      perimeter: '',
      remoteSelectType: RemoteSelectType.BOARD,
      remoteSelectValue: '',
      status: SynchronizationStatus.SUCCESS,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: true,
      syncErrorLogFilePath: '../logs/xsquash4jira/sync-2-error.log',
    },
    {
      id: 3,
      name: 'Jira Sync 3',
      serverId: 2,
      serverName: 'Jira Server',
      projectId: 3,
      projectName: 'example project 3',
      perimeter: '',
      remoteSelectType: RemoteSelectType.FILTER,
      remoteSelectValue: '',
      status: SynchronizationStatus.RUNNING,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: false,
      syncErrorLogFilePath: '',
    },
    {
      id: 4,
      name: 'Jira Sync 4',
      serverId: 2,
      serverName: 'Jira Server',
      projectId: 4,
      projectName: 'example project 4',
      perimeter: '',
      remoteSelectType: RemoteSelectType.QUERY,
      remoteSelectValue: '',
      status: SynchronizationStatus.NEVER_EXECUTED,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: true,
      syncErrorLogFilePath: '',
    },
  ];
}

export function mockXsquash4GitLabRemoteSyncData(): RemoteSynchronisation[] {
  const todayDate = new Date().toISOString();

  return [
    {
      id: 1,
      name: 'Sync1',
      serverId: 3,
      serverName: 'GitLab Server',
      projectId: 1,
      projectName: 'project 1',
      perimeter: 'henix/recette/squash',
      remoteSelectType: RemoteSelectType.ISSUE,
      remoteSelectValue: '',
      status: SynchronizationStatus.FAILURE,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: true,
      synchronizedRequirementsCount: 25,
      unprocessedRequirementsCount: 2,
      syncErrorLogFilePath: '../logs/xsquash4gitlab/sync-1-error.log',
    },
    {
      id: 2,
      name: 'Sync2',
      serverId: 3,
      serverName: 'GitLab Server',
      projectId: 2,
      projectName: 'project 2',
      perimeter: 'autom/projects',
      remoteSelectType: RemoteSelectType.ISSUE,
      remoteSelectValue: '',
      status: SynchronizationStatus.SUCCESS,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: true,
      synchronizedRequirementsCount: 25,
      unprocessedRequirementsCount: 0,
      syncErrorLogFilePath: '../logs/xsquash4gitlab/sync-2-error.log',
    },
    {
      id: 3,
      name: 'Sync3',
      serverId: 3,
      serverName: 'GitLab Server',
      projectId: 3,
      projectName: 'project 3',
      perimeter: 'jupiter/group',
      remoteSelectType: RemoteSelectType.BOARD,
      remoteSelectValue: '',
      status: SynchronizationStatus.RUNNING,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: false,
      synchronizedRequirementsCount: 0,
      unprocessedRequirementsCount: 7,
      synchronizedSprintTicketsCount: 8,
      unprocessedSprintTicketsCount: 0,
      syncErrorLogFilePath: '',
    },
    {
      id: 4,
      name: 'Sync4',
      serverId: 3,
      serverName: 'GitLab Server',
      projectId: 4,
      projectName: 'project 4',
      perimeter: 'neptune/group',
      remoteSelectType: RemoteSelectType.BOARD,
      remoteSelectValue: '',
      status: SynchronizationStatus.NEVER_EXECUTED,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: true,
      syncErrorLogFilePath: '',
    },
    {
      id: 5,
      name: 'Sync5',
      serverId: 3,
      serverName: 'GitLab Server',
      projectId: 4,
      projectName: 'project 5',
      perimeter: 'neptune/group',
      remoteSelectType: RemoteSelectType.BOARD,
      remoteSelectValue: '',
      status: SynchronizationStatus.FAILURE,
      lastSyncDate: todayDate,
      lastSuccessfulSyncDate: todayDate,
      enabled: true,
      syncErrorLogFilePath: '',
    },
  ];
}

export function makeUserData(customData?: Partial<User>): User {
  const defaultData: User = {
    id: 1,
    login: 'login',
    firstName: 'firstName',
    lastName: 'lastName',
    active: false,
    createdBy: '',
    createdOn: new Date().toISOString(),
    email: '',
    lastConnectedOn: new Date().toISOString(),
    lastModifiedBy: '',
    lastModifiedOn: new Date().toISOString(),
    projectPermissions: [],
    profiles: [],
    teams: [],
    canManageLocalPassword: true,
    usersGroupBinding: 2,
    usersGroups: [
      { id: 1, qualifiedName: 'squashtest.authz.group.core.Admin' },
      { id: 4, qualifiedName: 'squashtest.authz.group.tm.TestAutomationServer' },
      { id: 2, qualifiedName: 'squashtest.authz.group.tm.User' },
    ],
    canDeleteFromFront: false,
  };

  return combineWithDefaultData(defaultData, customData);
}

export function makeTeamData(customData?: Partial<Team>): Team {
  const defaultData: Team = {
    id: 1,
    name: 'name',
    createdBy: '',
    createdOn: undefined,
    description: '',
    lastModifiedBy: '',
    lastModifiedOn: undefined,
    members: [],
    projectPermissions: [],
    profiles: [],
  };

  return combineWithDefaultData(defaultData, customData);
}

export function makeMilestoneViewData(
  customData?: Partial<MilestoneAdminView>,
): MilestoneAdminView {
  const defaultData: MilestoneAdminView = {
    id: 1,
    createdBy: '',
    createdOn: undefined,
    description: '',
    endDate: new Date().toISOString(),
    label: '',
    lastModifiedBy: '',
    lastModifiedOn: new Date().toISOString(),
    ownerFistName: '',
    ownerLastName: '',
    ownerLogin: '',
    range: '',
    status: undefined,
    canEdit: false,
    boundProjectsInformation: [],
  };

  return combineWithDefaultData(defaultData, customData);
}

export function makeTAServerViewData(
  customData?: Partial<AdminTestAutomationServer>,
): AdminTestAutomationServer {
  const defaultData: AdminTestAutomationServer = {
    id: 1,
    name: 'TAServer',
    createdBy: '',
    createdOn: undefined,
    description: '',
    baseUrl: '',
    credentials: undefined,
    kind: TestAutomationServerKind.jenkins,
    lastModifiedBy: '',
    lastModifiedOn: undefined,
    manualSlaveSelection: false,
    authProtocol: AuthenticationProtocol.BASIC_AUTH,
    supportedAuthenticationProtocols: [AuthenticationProtocol.BASIC_AUTH],
    supportsAutomatedExecutionEnvironments: false,
    availableEnvironments: null,
    availableEnvironmentTags: null,
    environmentTags: null,
    observerUrl: null,
    eventBusUrl: null,
    killSwitchUrl: null,
  };

  return combineWithDefaultData(defaultData, customData);
}

export function mockBugTrackerReferentialDto(
  customData?: Partial<BugTrackerReferentialDto>,
): BugTrackerReferentialDto {
  return combineWithDefaultData(
    {
      id: 1,
      name: 'bugtracker',
      kind: 'dummy',
      authProtocol: AuthenticationProtocol.BASIC_AUTH,
      authPolicy: AuthenticationPolicy.APP_LEVEL,
      url: 'https://dummy',
      iframeFriendly: false,
      useProjectPaths: false,
      projectHelpMessage: null,
    },
    customData,
  );
}
